/*
Esercizo 1 del 24/2/2016 (rivisto 19/1/2018)
Scrivere un programma C che calcoli la funzione "ordinamento di sequenza" implementando l'algoritmo
QuickSort. Allo scopo, si completi il testo con gli eventuali vincoli che si ritengano necessari.
**
* Marco Bellia 
**
Soluzione.
Vincoli.
1) Esistenza bound, N, alla dimensione della sequenza da ordinare. Il bound è trattato come:
        Parametro di Programma
2) Elementi della sequenza di tipo noto. Il tipo è int.
3) Lettura numero elementi K (≤N) effetivi dela sequenza (da buffer di input)
4) Lettura elementi sequenza di sequito a lettura di valore K (da buffer input)
3) Relazione d'ordine assunta come operazione nota. Relazione < su int.
4) Sequenza realizzata come struttura ad accesso diretto: array (ad allocazione statica).
*/

#include <stdio.h>
#include <stdlib.h>

int N = 15; // Parametro di programma (non modificabile)
void QuickSort(int Left, int Right, int A[]){// procedura ricorsiva
    int I=Left;  //indici crescenti in [Left..Right]
    int J=Right; //indici decrescenti in [Left..Right]
    int temp=A[(Left+Right)/2];  //elemento di separazione
    while (I<=J) {
        while (A[I]<temp) I++;
        while (A[J]>temp) J--;
        if (I<=J){
            int scambia=A[I];
            A[I]=A[J];
            A[J]=scambia;
            I++; J--;
        }
    }
    if (Left<J) QuickSort(Left,J,A);
    if (I<Right) QuickSort(I,Right,A);
}

int main(void){
    // Allocaione Sequenza da ordinare
    int Seq[N];
    int k;
    //lettura sequenza k<=N interi da ordinare;
    int i=0;
    while (i<N && scanf("%d",&Seq[i])==1) i++;
    k=i-1; //-- K+1: size effettiva della sequenza
     //ordinamento QuickSort
    QuickSort(0,k,Seq);
    //stampa sequenza ordinata;
    for (int i=0; i<k; i++) printf("%d,",Seq[i]);
    printf("%d\n",Seq[k]);
    return(1);
}
